## cctools 9.9

=== Makefile ===
include config.mk
include rules.mk

CYGWINLIB = cygwin1.dll cyggcc_s-1.dll cygintl-8.dll cygreadline7.dll cygncursesw-10.dll cygiconv-2.dll cygattr-1.dll sh.exe

#set the default values for RPM_VERSION and RPM_RELEASE
RPM_VERSION=4.4.1
RPM_RELEASE=1

all: $(CCTOOLS_PACKAGES)

config.mk:
	@echo "You must run 'configure' before '${MAKE}'."
	@exit 1

makeflow wavefront: batch_job
batch_job parrot: chirp
batch_job chirp deltadb ftp_lite makeflow makeflow_linker parrot resource_monitor work_queue grow: dttools
parrot: ftp_lite grow
batch_job makeflow: work_queue
tlq: dttools

$(CCTOOLS_PACKAGES): config.mk
	@$(MAKE) -C $@

CLEAN_PACKAGES = $(CCTOOLS_PACKAGES:%=clean-%)
$(CLEAN_PACKAGES):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_PACKAGES)

INSTALL_PACKAGES = $(CCTOOLS_PACKAGES:%=install-%)
$(INSTALL_PACKAGES): $(CCTOOLS_PACKAGES)
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_PACKAGES)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	for file in $(CYGWINLIB) ; do if [ -f /bin/$$file ] ; then cp /bin/$$file $(CCTOOLS_INSTALL_DIR)/bin/ ; fi ; done
	mkdir -p ${CCTOOLS_INSTALL_DIR}/etc
	cp config.mk ${CCTOOLS_INSTALL_DIR}/etc/
	mkdir -p ${CCTOOLS_INSTALL_DIR}/doc
	cp COPYING ${CCTOOLS_INSTALL_DIR}/doc/
	cp README ${CCTOOLS_INSTALL_DIR}/doc/

test: $(CCTOOLS_PACKAGES)
	./run_all_tests.sh

rpm:
	./packaging/rpm/rpm_creator.sh $(RPM_VERSION) $(RPM_RELEASE)

.PHONY: $(CCTOOLS_PACKAGES) $(INSTALL_PACKAGES) $(CLEAN_PACKAGES) all clean install test rpm

=== dataswarm/Makefile ===
include ../config.mk
include ../rules.mk

PHONY_TARGETS ?= common manager worker
TARGETS ?= $(PHONY_TARGETS)

all: $(TARGETS)

common:
	@$(MAKE) -C $@

manager: common
	@$(MAKE) -C $@

worker: common
	@$(MAKE) -C $@

CLEAN_TARGETS = $(TARGETS:%=clean-%)
$(CLEAN_TARGETS):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_TARGETS)

INSTALL_TARGETS = $(TARGETS:%=install-%)
$(INSTALL_TARGETS):
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_TARGETS)

TEST_TARGETS = $(TARGETS:%=test-%)
$(TEST_TARGETS):
	@$(MAKE) -C $(@:test-%=%) test
test: $(TEST_TARGETS)

.PHONY: $(PHONY_TARGETS) $(CLEAN_TARGETS) $(INSTALL_TARGETS) $(TEST_TARGETS) clean install test

=== doc/requirements.txt ===
# pip packages required for building the documentation via mkdocs
pymdown-extensions

=== dttools/Makefile ===
include ../config.mk
include ../rules.mk

PHONY_TARGETS ?= src
TARGETS ?= $(PHONY_TARGETS)

all: $(TARGETS)

$(TARGETS):
	@$(MAKE) -C $@

CLEAN_TARGETS = $(TARGETS:%=clean-%)
$(CLEAN_TARGETS):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_TARGETS)

INSTALL_TARGETS = $(TARGETS:%=install-%)
$(INSTALL_TARGETS):
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_TARGETS)

TEST_TARGETS = $(TARGETS:%=test-%)
$(TEST_TARGETS):
	@$(MAKE) -C $(@:test-%=%) test
test: $(TEST_TARGETS)

.PHONY: $(PHONY_TARGETS) $(CLEAN_TARGETS) $(INSTALL_TARGETS) $(TEST_TARGETS) all clean install test

=== tlq/Makefile ===
all:
	cp ../dttools/src/jx_test client
	
clean:
	@echo Cleaning TLQ installation.
	cd client && rm -rf .tlq_session.log deposits.log jx_test

install:

.PHONY: all clean install

# vim: set noexpandtab tabstop=4:

=== apps/wq_bwa_json/Makefile ===
BWA_VERSION=bwa-0.7.17

all: bwa work_queue_server work_queue_server.py ref.fastq.ann query.fastq.0.gz

work_queue_server:
	ln -s ../../work_queue/src/work_queue_server .

work_queue_server.py:
	ln -s ../../work_queue/src/clients/python3/work_queue_server.py .

bwa: ${BWA_VERSION}
	cd ${BWA_VERSION} && make && cd .. && cp ${BWA_VERSION}/bwa .

${BWA_VERSION}:
	curl -L https://sourceforge.net/projects/bio-bwa/files/${BWA_VERSION}.tar.bz2/download > ${BWA_VERSION}.tar.bz2
	bunzip2 ${BWA_VERSION}.tar.bz2
	tar xvf ${BWA_VERSION}.tar

ref.fastq: fastq_generate.pl
	./fastq_generate.pl 100000 1000 > ref.fastq

query.fastq: fastq_generate.pl
	./fastq_generate.pl 10000000 10 > query.fastq      #5 splits

ref.fastq.ann: ref.fastq bwa
	./bwa index ref.fastq

query.fastq.0: query.fastq create_splits.py
	./create_splits.py

query.fastq.0.gz: query.fastq.0
	gzip -f query.fastq.*

clean:
	rm -rf query.fastq.0.* ref.fastq ref.fastq.* query.fastq ${BWA_VERSION} ${BWA_VERSION}.* bwa work_queue_server.py work_queue_server *.pyc

=== chirp/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 - allow mmap of database.
# -DSQLITE_TEMP_STORE=3 - only use memory for temporary files.
# -DSQLITE_THREADSAFE=0 - we only use sqlite3 multi-process (i.e. no threads). This disables somewhat costly mutex locks.
LOCAL_CCFLAGS = -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 -DSQLITE_TEMP_STORE=3 -DSQLITE_THREADSAFE=0 -fstack-protector-all

# Globus is needed by all executables via libdttools.a/auth_globus.o
LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libchirp.a libconfuga.a
OBJECTS = chirp_tool.o chirp_fuse.o $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) $(OBJECTS_SERVER) $(OBJECTS_PROGRAMS)
OBJECTS_CONFUGA = $(SOURCES_CONFUGA:%.c=%.o)
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_SERVER = $(SOURCES_SERVER:%.c=%.o)
OBJECTS_PROGRAMS = $(PROGRAMS:%=%.o)
PROGRAMS = $(PROGRAMS_CHIRP) $(PROGRAMS_CONFUGA)
PROGRAMS_CHIRP = chirp chirp_get chirp_put chirp_server chirp_status chirp_benchmark chirp_stream_files chirp_fuse chirp_distribute
PROGRAMS_CONFUGA = confuga_adm
PUBLIC_HEADERS = chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h confuga.h
SCRIPTS = chirp_audit_cluster chirp_server_hdfs
SOURCES_CONFUGA = confuga.c confuga_namespace.c confuga_replica.c confuga_node.c confuga_job.c confuga_file.c confuga_gc.c
SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c json.c json_aux.c
SOURCES_SERVER = sqlite3.c chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_local_scheduler.c chirp_fs_chirp.c chirp_fs_confuga.c chirp_job.c chirp_sqlite.c
TARGETS = $(PROGRAMS) $(LIBRARIES)

all: $(TARGETS) bindings

chirp: chirp_tool.o
ifeq ($(CCTOOLS_STATIC),1)
	$(CCTOOLS_LD) -static -g -o $@ $(LOCAL_LINKAGE) $^ $(CCTOOLS_STATIC_LINKAGE)
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)
endif

ifeq ($(CCTOOLS_STATIC),1)
chirp_fuse:
	@echo "chirp_fuse cannot be built statically"
else
chirp_fuse: chirp_fuse.o
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_FUSE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

chirp_fuse.o: chirp_fuse.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_FUSE_CCFLAGS) $<
endif

chirp_job.o chirp_fs_local_scheduler.o: chirp_sqlite.h

# This is the library intended to be used by clients of the system.
libchirp.a: $(OBJECTS_LIBRARY)

confuga.o confuga_job.o confuga_namespace.o confuga_node.o confuga_replica.o confuga_file.o: confuga.h confuga_fs.h chirp_sqlite.h
libconfuga.a: $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) chirp_sqlite.o sqlite3.o
libconfuga.$(CCTOOLS_DYNAMIC_SUFFIX): $(OBJECTS_CONFUGA) ../../dttools/src/auth_all.o $(EXTERNAL_DEPENDENCIES)

chirp_server: $(OBJECTS_SERVER) libconfuga.a
$(PROGRAMS_CONFUGA): libconfuga.a libchirp.a $(EXTERNAL_DEPENDENCIES)
$(PROGRAMS_CHIRP): libchirp.a $(EXTERNAL_DEPENDENCIES)

bindings: chirp_swig_wrap.o libchirp.a libconfuga.a $(EXTERNAL_DEPENDENCIES)
	@$(MAKE) -C bindings

clean:
	rm -f $(OBJECTS) $(TARGETS)
	@$(MAKE) -C bindings clean

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	if [ -f $(CCTOOLS_INSTALL_DIR)/bin/chirp_server ]; then mv $(CCTOOLS_INSTALL_DIR)/bin/chirp_server $(CCTOOLS_INSTALL_DIR)/bin/chirp_server.old; fi
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	cp -r ../tools/workflows/ $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	@$(MAKE) -C bindings install

test: all
	@$(MAKE) -C bindings test

.PHONY: all clean install test bindings

=== dataswarm/common/Makefile ===
include ../../config.mk
include ../../rules.mk

SOURCES=ds_mount.c ds_resources.c ds_task.c ds_message.c ds_blob.c ds_task_attempt.c
OBJECTS=$(SOURCES:%.c=%.o)
LOCAL_LINKAGE = -L ../../dttools/src -ldttools

all: libdataswarm_common.a

libdataswarm_common.a: $(OBJECTS)
	ar rv $@ $^

clean:
	rm -rf $(OBJECTS) libdataswarm_common.a

install:

test: all

.PHONY: all clean install test

=== dataswarm/manager/Makefile ===
include ../../config.mk
include ../../rules.mk

TARGETS=$(PROGRAMS)
PROGRAMS=ds_manager

SOURCES=ds_manager.c ds_scheduler.c ds_client_rep.c ds_worker_rep.c ds_rpc.c ds_test.c ds_client_ops.c ds_validate.c ds_file.c ds_catalog_update.c
OBJECTS=$(SOURCES:%.c=%.o)
LOCAL_CCFLAGS = -I ../common
LOCAL_LINKAGE = -L ../common -ldataswarm_common -L ../../dttools/src -ldttools

all: $(TARGETS)

ds_manager: $(OBJECTS)

clean:
	rm -rf $(OBJECTS) $(PROGRAMS)

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin

test: all

.PHONY: all clean install test bindings

=== dataswarm/worker/Makefile ===
include ../../config.mk
include ../../rules.mk

TARGETS=$(PROGRAMS)
PROGRAMS=ds_worker

SOURCES=ds_worker_main.c ds_worker.c ds_process.c ds_task_table.c ds_blob_table.c ds_measure.c
OBJECTS=$(SOURCES:%.c=%.o)

LOCAL_CCFLAGS = -I ../common
LOCAL_LINKAGE = -L ../common -ldataswarm_common -L ../../dttools/src -ldttools

all: $(TARGETS)

ds_worker: $(OBJECTS)

clean:
	rm -rf $(OBJECTS) $(PROGRAMS)

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin

test: all

.PHONY: all clean install test bindings

=== deltadb/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libdeltadb.a
OBJECTS = $(SOURCES:%.c=%.o)
PROGRAMS = deltadb_query deltadb_upgrade_log catalog_server
SCRIPTS =
SOURCES = deltadb.c deltadb_query.c deltadb_stream.c deltadb_reduction.c
TARGETS = $(LIBRARIES) $(PROGRAMS)

all: $(TARGETS)

libdeltadb.a: $(OBJECTS)

deltadb_query: deltadb_query_main.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

deltadb_upgrade_log: deltadb_upgrade_log.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

catalog_server: catalog_server.o libdeltadb.a $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin

test: all

.PHONY: all clean install test

=== dttools/src/Makefile ===
include ../../config.mk
include ../../rules.mk

SOURCES = \
	address.c \
	auth.c \
	auth_address.c \
	auth_all.c \
	auth_globus.c \
	auth_hostname.c \
	auth_kerberos.c \
	auth_ticket.c \
	auth_unix.c \
	b64.c \
	bitmap.c \
	buffer.c \
	catalog_query.c \
	category.c \
	cctools.c \
	cctools_endian.c \
	change_process_title.c \
	chunk.c \
	clean_dir.c \
	compat-at.c \
	console_login.c \
	copy_stream.c \
	copy_tree.c \
	create_dir.c \
	daemon.c \
	datagram.c \
	debug.c \
	debug_file.c \
	debug_journal.c \
	debug_stream.c \
	debug_syslog.c \
	disk_alloc.c \
	domain_name.c \
	domain_name_cache.c \
	dpopen.c \
	elfheader.c \
	envtools.c \
	env_replace.c \
	fast_popen.c \
	fd.c \
	file_cache.c \
	full_io.c \
	get_canonical_path.c \
	get_line.c \
	getopt.c \
	getopt_aux.c \
	gpu_info.c \
	hash_cache.c \
	hash_table.c \
	hdfs_library.c \
	histogram.c \
	hmac.c \
	host_disk_info.c \
	host_memory_info.c \
	http_query.c \
	interfaces_address.c \
	itable.c \
	jx.c \
	jx_binary.c\
	jx_getopt.c \
	jx_match.c \
	jx_parse.c \
	jx_print.c \
	jx_pretty_print.c \
	jx_canonicalize.c \
	jx_table.c \
	jx_export.c \
	jx_eval.c \
	jx_sub.c \
	jx_function.c \
	link.c \
	link_auth.c \
	list.c \
	load_average.c \
	md5.c \
	memfdexe.c \
	mkdir_recursive.c \
	mq.c \
	twister.c \
	nvpair.c \
	nvpair_jx.c \
	password_cache.c \
	path.c \
	path_disk_size_info.c \
	pattern.c \
	ppoll_compat.c \
	preadwrite.c \
	process.c \
	random.c \
	rmonitor.c \
	rmonitor_poll.c \
	rmsummary.c \
	set.c \
	semaphore.c \
	sha1.c \
	shell.c \
	sh_popen.c\
	sigdef.c \
	sleeptools.c \
	sort_dir.c \
	stats.c \
	string_array.c \
	stringtools.c \
	string_set.c \
	text_array.c \
	text_list.c \
	timer.c \
	timestamp.c \
	tlq_config.c \
	unlink_recursive.c \
	uptime.c \
	url_encode.c \
	username.c \
	uuid.c \
	xxmalloc.c \

HEADERS_PUBLIC = \
	auth.h \
	auth_address.h \
	auth_all.h \
	auth_globus.h \
	auth_hostname.h \
	auth_kerberos.h \
	auth_ticket.h \
	auth_unix.h \
	bitmap.h \
	buffer.h \
	category.h \
	cctools.h \
	copy_tree.h \
	compat-at.h \
	debug.h \
	delete_dir.h \
	envtools.h \
	fast_popen.h \
	full_io.h \
	getopt.h \
	getopt_aux.h \
	hash_table.h \
	histogram.h \
	host_memory_info.h \
	http_query.h \
	int_sizes.h \
	itable.h \
	jx.h \
	jx_match.h \
	link.h \
	list.h \
	load_average.h \
	md5.h \
	macros.h \
	mq.h \
	path.h \
	rmonitor_poll.h \
	rmsummary.h \
	stringtools.h \
	text_array.h \
	text_list.h \
	timestamp.h \
	unlink_recursive.h \
	xxmalloc.h \

LIBRARIES = libdttools.a

ifneq ($(CCTOOLS_STATIC),1)
PRELOAD_LIBRARIES = libforce_halt_enospc.so
endif

ifeq ($(CCTOOLS_CURL_AVAILABLE),yes)
CCTOOLS_EXTERNAL_LINKAGE += $(CCTOOLS_CURL_LDFLAGS) -lssl -lcrypto
SOURCES += s3_file_io.c
HEADERS_PUBLIC += s3_file_io.h
endif

OBJECTS = $(SOURCES:%.c=%.o)

#separate, because catalog_query has a slightly different order of linking.
MOST_PROGRAMS = catalog_update watchdog disk_allocator jx2json jx2env jx_repl env_replace
PROGRAMS = $(MOST_PROGRAMS) catalog_query

SCRIPTS = cctools_gpu_autodetect
TARGETS = $(LIBRARIES) $(PRELOAD_LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS)
TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test histogram_test category_test jx_binary_test mq_poll_test mq_wait_test mq_store_test

all: $(TARGETS) catalog_query

libdttools.a: $(OBJECTS)

$(MOST_PROGRAMS) $(TEST_PROGRAMS): libdttools.a

jx_repl: jx_repl.o libdttools.a
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)

catalog_query: catalog_query.o catalog_query_tool.o libdttools.a

auth_globus.o: auth_globus.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_GLOBUS_CCFLAGS) $<

auth_test: auth_test.o libdttools.a
ifeq ($(CCTOOLS_STATIC),1)
	@echo "auth_test currently cannot be build statically."
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

libforce_halt_enospc.so: libforce_halt_enospc.o
	$(CCTOOLS_CC) -shared -fPIC $^ -o $@ -ldl

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(SCRIPTS) $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(PRELOAD_LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/

test: all

.PHONY: all clean install test

# vim: set noexpandtab tabstop=4:

=== debian/changelog ===
cctools (9.9-4ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:47:05 +0000

cctools (9.9-4ubuntu3) noble; urgency=medium

  * Undefine _FILE_OFFSET_BITS and _TIME_BITS in rmonitor_helper.c so the library's
    interposition of open/open64 still works.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 20 Mar 2024 15:59:17 +1300

cctools (9.9-4ubuntu2) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:14:39 +0000

cctools (9.9-4ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Dec 2023 14:22:56 +0100

cctools (9.9-3ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Nov 2023 17:53:19 +0100

cctools (9.9-2ubuntu6) noble; urgency=medium

  * No-change rebuild with Python 3.12 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 31 Oct 2023 16:59:41 +0000

cctools (9.9-2ubuntu5) lunar; urgency=medium

  * Rebuild to drop Python 3.10 extension

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 28 Feb 2023 17:19:52 -0500

cctools (9.9-2ubuntu4) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as supported

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 02 Nov 2022 08:25:26 +0000

cctools (9.9-2ubuntu3) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:21:20 +0000

cctools (9.9-2ubuntu2) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Oct 2021 09:53:34 +0200

cctools (9.9-2ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Sep 2021 14:39:59 +0200

cctools (9.9-1ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Aug 2021 16:30:05 +0200

=== debian/control ===
Source: cctools
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-python3,
  python3-all-dev, 
  python3-examples,
  libglobus-common-dev,
  default-libmysqlclient-dev,
  libfuse-dev,
  libext2fs-dev,
  libossp-uuid-dev,
  libperl-dev,
  libkrb5-dev,
  libsqlite3-dev,
  pkg-config,
  golang-go [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !sh4 !ia64 !alpha !hppa !m68k !powerpc !ppc64 !x32],
  libglobus-gss-assist-dev, net-tools, doxygen,
  libreadline6-dev | libreadline-dev | libeditreadline-dev, 
  libncurses5-dev | libncurses-dev, 
  libjsonparser-dev,
  swig,
  m4, 
  mpi-default-dev
Standards-Version: 4.6.2
Homepage: https://ccl.cse.nd.edu/software/
Vcs-Browser: https://salsa.debian.org:/neurodebian-team/cctools.git
Vcs-Git: https://salsa.debian.org:/neurodebian-team/cctools.git -b debian/latest

Package: coop-computing-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: coop-computing-tools-doc, condor, gridengine-client
Description: cooperative computing tools
 This is a collection of software that help users to share resources in a
 complex, heterogeneous, and unreliable computing environment. This includes:
 .
  * Chirp: A personal filesystem and I/O protocol that allows unprivileged users
    to share space securely, efficiently, and conveniently. When combined
    with Parrot, Chirp allows users to create custom wide-area
    distributed filesystems.
  * Parrot: A transparent user-level virtual filesystem that allows any ordinary
    program to be attached to a remote storage device such as an FTP
    server or a Chirp server.
  * Makeflow: A workflow system for parallel and distributed computing that uses
    a language very similar to Make.
  * Work Queue: A system and API for building master-worker style programs that
    scale up to thousands of processors.
  * All Pairs: A computational abstraction for running very large Cartesian
    products.
  * Wavefront: A computational abstraction for running very large dynamic
    programming problems.
  * The Fault Tolerant Shell: A high-level programming language that allows
    users to combine the ease of shell scripting, the power of distributed
    programming, and the precision of compiled languages. Basically,
    parallel programming and exception handling for scripts.

Package: coop-computing-tools-dev
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries and header files for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides static libraries and header files for development.

Package: coop-computing-tools-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: documentation for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides the documentation (manual and API reference) in HTML
 format.

Package: python3-workqueue
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3
Description: cooperative computing tools work queue Python3 bindings
 CCTools's Work Queue is a system and API for building master-worker style
 programs that scale up to thousands of processors. This package provides
 bindings to access this system from Python3.

=== debian/rules ===
#!/usr/bin/make -f

non_default_python3_versions = $(shell python3 -c "print (\"`py3versions -v -s`\".replace(\"`py3versions -v -d`\", '').strip())")

export DH_VERBOSE=1

# one ring to rule them all ...
%:
	dh $@  --no-parallel

PY3:=$(shell py3versions -d)
CF:=$(shell dpkg-buildflags --get CFLAGS) -O0

ARCH_NOGOLANG:= hurd-i386 kfreebsd-amd64 kfreebsd-i386 sh4 ia64 alpha hppa m68k powerpc ppc64 x32
GOLANG:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NOGOLANG)),,--with-golang-path=/usr)

override_dh_auto_configure:
	# disable warning about unused results (necessary because warning is error
	# is ON)
	CFLAGS="$(CF) -I /usr/include/$(PY3) -DNDEBUG -Wno-unused-result" bash ./configure --with-globus-path=/usr \
		--prefix=/usr \
		$(GOLANG) \
		--with-krb5-path=/usr --with-readline-path=/usr \
		--with-mpi-path=/usr --with-fuse-path=/usr --with-zlib-path=/usr \
		--with-python3-path /usr/bin/python3 \
		--with-python2-path no \
		--without-system-parrot \
		--build-date "$(shell LC_ALL=C date --utc --date=@$${SOURCE_DATE_EPOCH})" 

override_dh_auto_test:
	# disable the tests for now on upstream's request. they will be reenabled
	# once the test suite can properly deal with the buildd environment

override_dh_auto_install:
	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp 
	# make extensions for other supported python versions
	if [ -n "$(non_default_python3_versions)" ]; then \
		for pyver in $(non_default_python3_versions); do \
			CFLAGS="$(CF) -I /usr/include/python$${pyver} -DNDEBUG -Wno-unused-result" \
			bash ./configure --prefix --with-globus-path=/usr --with-krb5-path=/usr --with-readline-path=/usr \
				--with-mpi-path=/usr --with-fuse-path=/usr --with-zlib-path=/usr \
				--with-python3-path /usr/bin/python$${pyver} --with-python2-path no ; \
			make -B -C work_queue/src/bindings/python3 clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
			make -B -C resource_monitor/src clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp  ; \
			make -B -C chirp/src clean install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp  ; \
		done ; \
	fi
	# for now remove the 'apps' scripts till upstream confirms that the language
	# extension can be removed
	rm -f debian/tmp/bin/*.py
	find debian -name .gitignore -delete
	# fix permissions
	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
	# remove undesired pieces
	-rm debian/tmp/doc/COPYING
	# upstream says it should not go into the page
	-rm debian/tmp/bin/watchdog
	# HDFS helpers are useless without HDFS in Debian
	-rm debian/tmp/bin/*_hdfs
	# newer doxygen puts jquery copy
	#-rm debian/tmp/doc/api/html/jquery.js
	$(MAKE) doc

override_dh_auto_clean:
	[ -e Makefile.config ] && dh_auto_clean || true
	-rm -f Makefile.config configure.rerun
	-rm -rf api hdfs-setup.template python/python-workqueue/setup.cfg
	# remove testrun left-overs
	-rm dttools/src/microbench dttools/src/work_queue_example
	-find $(CURDIR) -name '*.test.log' -delete
	-find $(CURDIR) -name '*_test' -delete
	-find $(CURDIR) -name '*.[ao]' -delete
	-find $(CURDIR) -name '*.so' -delete
	find doc/man/md/ -name '*.md' -delete
	find doc/man/ -name '*.1' -delete
	find doc/man -name '*.html' -delete
	-rm -f work_queue/src/work_queue_example work_queue/src/work_queue_example_json work_queue/src/work_queue_status
	-rm -f work_queue/src/work_queue_test_watch resource_monitor/src/rmonitor_snapshot work_queue/src/work_queue_worker
	-rm -f work_queue/src/work_queue_server resource_monitor/src/resource_monitor resource_monitor/src/rmonitor_poll_example
	-rm -f batch_job/src/work_queue_factory resource_monitor/src/piggybacker makeflow/src/makeflow_mpi_submitter
	-rm -rf sand/test/filter_verification/random.cand.filter.tmp/
	-rm -rf sand/test/test_20.cand.filter.tmp/
	-rm -f sand/test/test_20.cand sand/test/test_20.cfa sand/test/*.log
	-rm -rf makeflow/test/input/ makeflow/test/worker.pid
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.makeflowlog
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.wqlog
	-rm -rf makeflow/test/src/
	-rm dttools/src/multirun sand/test/banded.log makeflow/src/makeflow makeflow/src/makeflow_viz batch_job/src/work_queue_pool
	-rm -f makeflow/src/makeflow_mpi_starter makeflow/src/makeflow_analyze grow/src/grow_fuse dttools/src/jx_repl
	-rm -f chirp/src/chirp dttools/src/catalog_update dttools/src/env_replace makeflow/src/makeflow_linker
	-rm -f makeflow/src/makeflow_status dttools/src/jx2env dttools/src/jx2json dttools/src/watchdog ftp_lite/src/ftp_lite_copy
	-rm -f chirp/src/chirp_benchmark deltadb/src/deltadb_upgrade_log dttools/src/disk_allocator deltadb/src/deltadb_query
	-rm -f chirp/src/chirp_distribute chirp/src/chirp_status dataswarm/worker/ds_worker deltadb/src/catalog_server dttools/src/catalog_query
	-rm -f dataswarm/manager/ds_manager chirp/src/chirp_stream_files chirp/src/confuga_adm chirp/src/chirp_fuse chirp/src/chirp_get
	-rm -f chirp/src/chirp_put chirp/src/chirp_server chirp/src/bindings/python3/Python.framework
	-rm -f work_queue/src/bindings/python3/Python.framework work_queue/src/sge_submit_workers
	for d in chirp/src/bindings/perl/CChirp.pm chirp/src/bindings/perl/chirp_wrap.c chirp/src/bindings/python3/CChirp.py \
 		chirp/src/bindings/python3/Chirp.py chirp/src/bindings/python3/chirp_wrap.c config.mk \
		doc/api/html/chirp_client_perl.html doc/api/html/chirp_stat_perl.html doc/api/html/work_queue_perl.html	\
 		doc/api/html/work_queue_task_perl.html resource_monitor/src/bindings/python3/resource_monitor.py \
		resource_monitor/src/bindings/python3/rmonitor_wrap.c resource_monitor/src/rmonitor_piggyback.h \
 		work_queue/src/bindings/perl/work_queue.pm work_queue/src/bindings/perl/work_queue_wrap.c \
		work_queue/src/bindings/python3/work_queue.py work_queue/src/bindings/python3/work_queue_wrap.c ; \
		do rm -f $$d ; done
